<?php
/*
 * Copyright(c) 2015 PAYDESIGN, Inc. All rights reserved.
 * http://www.paydesign.co.jp/
 */

namespace Plugin\PayDesign\Form\Type;

use Plugin\PayDesign\Controller\Util\PluginUtil;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormError;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\Validator\Constraints as Assert;

class ConvenienceType extends AbstractType
{
    private $app;

    public function __construct(\Eccube\Application $app, $subData = null)
    {
        $this->app = $app;
    }

    /**
     * Build config type form
     *
     * @param FormBuilderInterface $builder
     * @param array $options
     * @return type
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $objPluginUtil =& PluginUtil::getInstance($this->app);
        $objPluginUtil->install();
        $arrConvenience = $objPluginUtil->getConvenienceInfo(true);// trueは選択したコンビニのみ抽出

        $builder
            ->add('convenience', 'choice', array(
                'label' => 'ご利用コンビニ',
                'choices' => $arrConvenience,
                'multiple'=> false,
                'expanded' => false,
                'required' => false,
                'empty_value' => 'ご利用するコンビニを選択してください',
                'empty_data' => '',
                'constraints' => array(
                    new Assert\NotBlank(array('message' => '※ ご利用コンビニが選択されていません。')),
                ),
            ))
            ->addEventSubscriber(new \Eccube\Event\FormEventSubscriber());
    }

    /**
     * {@inheritdoc}
     */
    public function getName()
    {
        return 'paydesign_convenience';
    }
}
?>
