<?php
/*
 * Copyright(c) 2015 PAYDESIGN, Inc. All rights reserved.
 * http://www.paydesign.co.jp/
 */

namespace Plugin\PayDesign\Form\Type;

use Plugin\PayDesign\Controller\Util\PluginUtil;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\FormError;
use Symfony\Component\Form\FormEvents;
use Symfony\Component\Validator\Constraints as Assert;

class MypagePeriodicType extends AbstractType
{
    protected $app;
    protected $config;

    public function __construct(\Eccube\Application $app)
    {
        $this->app = $app;
        $this->config = $app['config'];
    }

    /**
     * Build config type form
     *
     * @param FormBuilderInterface $builder
     * @param array $options
     * @return type
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        // 申込状況一覧を取得
        $objPluginUtil =& PluginUtil::getInstance($this->app);
        $objPluginUtil->install();
        $arrPeriodicStatus = $objPluginUtil->getPeriodicStatus();
        unset($arrPeriodicStatus[4]);//[退会]は不要なので削除

        $builder
            ->add('periodic_status', 'choice', array(
                'label' => '申込状況',
                'required' => false,
                'choices' => $arrPeriodicStatus,
              /*'constraints' => array(
                    new Assert\NotBlank(array('message' => '※ 申込状況が選択されていません。')),
                ),*/

            ))
            ->add('periodic_next_date', 'date', array(
                'label' => '次回注文日',
                'required' => true,
                'input' => 'datetime',
                'widget' => 'single_text',
                'format' => 'yyyy-MM-dd',
            ))
            ->addEventSubscriber(new \Eccube\Event\FormEventSubscriber());
    }

    /**
     * {@inheritdoc}
     */
    public function getName()
    {
        return 'paydesign_mypage_periodic';
    }
}
?>
