<?php
/*
 * Copyright(c) 2015 PAYDESIGN, Inc. All rights reserved.
 * http://www.paydesign.co.jp/
 */

namespace Plugin\PayDesign;

use Eccube\Plugin\AbstractPluginManager;

class PluginManager extends AbstractPluginManager {

    /**
     * JS folder path (copy source)
     * @var type
     */
    protected $jsSrc;

    /**
     * JS folder path (copy destination)
     * @var type
     */
    protected $jsDst;

    public function __construct()
    {
        $this->jsSrc = __DIR__ . '/Resource/js/';
        $this->jsDst = __DIR__ . '/../../../html/plugin/paydesign/js';
    }

    public function install($config, $app)
    {
        $this->migrationSchema($app, __DIR__ . '/Migration', $config['code']);

        // Copy JS from PayDesign/Resource/js  to  /html/plugin/paydesgin/js/
        $this->copyFiles($this->jsSrc, $this->jsDst);
    }

    public function uninstall($config, $app)
    {
        $this->migrationSchema($app, __DIR__ . '/Migration', $config['code'], 0);

        // Remove JS in /html/plugin/paydesgin/js/
        $this->removeFiles($this->jsDst);
    }

    public function enable($config, $app)
    {

    }

    public function disable($config, $app)
    {

    }

    public function update($config, $app)
    {

    }

    /**
     * Recursively copy files from $src path to $dst path
     * @param string $src
     * @param string $dst
     */
    protected function copyFiles($src, $dst)
    {
        // コピー元ファイル（ディレクトリ）が存在しなければ終了
        if (!file_exists($src)) return;

        $dir = opendir($src);
        @mkdir($dst);
        while (false !== ($file = readdir($dir))) {
            if (($file != '.') && ($file != '..')) {
                if (is_dir($src . '/' . $file)) {
                    $this->copyFiles($src . '/' . $file, $dst . '/' . $file);
                } else {
                    copy($src . '/' . $file, $dst . '/' . $file);
                }
            }
        }
        closedir($dir);
    }

    /**
     * Recursively delete files in a folder path
     * @param string $dir
     * @return boolean
     */
    function removeFiles($dir)
    {
        // 削除対象ファイル（ディレクトリ）が存在しなければ終了
        if (!file_exists($dir)) return true;

        if (!is_dir($dir) || is_link($dir))
            return unlink($dir);
        foreach (scandir($dir) as $item) {
            if ($item == '.' || $item == '..')
                continue;
            if (!$this->removeFiles($dir . "/" . $item)) {
                chmod($dir . "/" . $item, 0777);
                if (!$this->removeFiles($dir . "/" . $item))
                    return false;
            };
        }
        return rmdir($dir);
    }
}
?>
